#include "hmg.ch"

Procedure Rep_stavke

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   SET DATE GERMAN // for test
   SET CENTURY ON  // for test

   *SET procedure to use_dbf // for test

   _date1 = date()-60
   _date2 = date() 
   
   DEFINE WINDOW Rep_2 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "Changes" ;
      MODAL ;

      ON KEY ESCAPE ACTION Rep_2.Release 

      @ 50, 100  LABEL Label_1 VALUE nls_lang(115)
      @ 50, 150  TEXTBOX  pDATE1 VALUE _Date1 DATE 
      @ 80, 100  LABEL Label_2 VALUE nls_lang(116)
      @ 80, 150  TEXTBOX  pDATE2 VALUE _Date2 DATE 
	  
   @ 150, 150 BUTTON PRINT_5732 ;
      CAPTION nls_lang(107) ;
      ACTION rep_create_5732() ;
      WIDTH 100

   END WINDOW

   Rep_2.CENTER
   ACTIVATE WINDOW Rep_2

RETURN
*----------------------------------------*
PROCEDURE rep_create_5732

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280, nVMargin:=10, nHMargin:=10 
PRIVATE cFontName:="Verdana", nFontSize:=8, nFontHeight:=4, nCharWidth:=2 

_date1 := Rep_2.pDate1.Value
_date2 := Rep_2.pDate2.Value

pre_report2( _date1, _date2 )

USE_REPORT2()   // function from USE_DBF.prg 

set filter to date1 >= _date1 .and. date1 <= _date2

brk_01    := PAY_ID    
brk_on_01 := .F.
prt_01    := .T.
sum_01_04 := 0 
sum_01_05 := 0 

sumr_04 := 0 
sumr_05 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( nls_lang(109) )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

sumr_04 := sumr_04 + EXPENSE   
sumr_05 := sumr_05 + PAYMENT   

   IF brk_01 <> PAY_ID    
      brk_on_01 := .T.
      prt_01    := .T.
   ENDIF

   IF brk_01 <> PAY_ID .OR. brk_on_01

      nCurLine += nFontHeight
      nCurCol = nHMargin + 1 * nCharWidth
      @ nCurLine, nCurCol PRINT replicate("*",  6) FONT cFontName SIZE nFontSize 
      nCurCol = nHMargin + 40 * nCharWidth
      nCurCol2 = nCurCol + 12 * nCharWidth
      @ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1
      nCurCol = nHMargin + 53 * nCharWidth
      nCurCol2 = nCurCol + 12 * nCharWidth
      @ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1

      nCurLine += nFontHeight
      nCurCol = nHMargin + 1 * nCharWidth
      @ nCurLine, nCurCol PRINT "sum" FONT cFontName SIZE nFontSize
      nCurCol = nHMargin + 40 * nCharWidth + 12 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_04, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT
      nCurCol = nHMargin + 53 * nCharWidth + 12 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_05, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT
      nCurLine += nFontHeight

      brk_01 := PAY_ID    
      brk_on_01 := .F.
      sum_01_04 := 0 
      sum_01_05 := 0 

   ENDIF

   sum_01_04 := sum_01_04 + EXPENSE   
   sum_01_05 := sum_01_05 + PAYMENT   

   IF nCurLine > nPageSize
      hdr_5732()
   ENDIF

   nCurLine += nFontHeight
   IF prt_01
      nCurCol = nHMargin + 1 * nCharWidth + 6 * nCharWidth 
      @ nCurLine, nCurCol PRINT  TRANSFORM ( PAY_ID, "999") FONT cFontName SIZE nFontSize RIGHT
      prt_01 := .F.
   ENDIF
   nCurCol = nHMargin + 8 * nCharWidth
   @ nCurLine, nCurCol PRINT DATE1      FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 19 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( DESCRIPT, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 40 * nCharWidth + 12 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( EXPENSE, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 53 * nCharWidth + 12 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYMENT, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 66 * nCharWidth
   @ nCurLine, nCurCol PRINT DATE2      FONT cFontName SIZE nFontSize
   nCurCol = nHMargin + 77 * nCharWidth
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PAYDESC, "XXXXXXXXXXXXXXXXXXXX") FONT cFontName SIZE nFontSize

   DBSKIP()
ENDDO

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT replicate("*",  6) FONT cFontName SIZE nFontSize
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1 
nCurCol = nHMargin + 53 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .1 

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT "sum" FONT cFontName SIZE nFontSize
nCurCol = nHMargin + 40 * nCharWidth + 12 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_04, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT
nCurCol = nHMargin + 53 * nCharWidth + 12 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sum_01_05, "9,999,999.99") FONT cFontName SIZE nFontSize RIGHT

nCurLine += nFontHeight
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 53 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

nCurLine += nFontHeight
nCurCol = nHMargin + 40 * nCharWidth + 12 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_04, "9,999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT
nCurCol = nHMargin + 53 * nCharWidth + 12 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_05, "9,999,999.99") FONT cFontName SIZE nFontSize BOLD RIGHT

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_2.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_5732

nCurPage++
nCurLine := nVMargin

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT nls_lang(112) + DTOC(date()) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 180 PRINT nls_lang(113) + STR(nCurPage, 3) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 100 PRINT nls_lang(119) FONT cFontName SIZE nFontSize+2 CENTER BOLD
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT "PAY_ID" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 8 * nCharWidth
@ nCurLine, nCurCol PRINT "DATE1" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 19 * nCharWidth
@ nCurLine, nCurCol PRINT "DESCRIPT" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 40 * nCharWidth
@ nCurLine, nCurCol PRINT "EXPENSE" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 53 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYMENT" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 66 * nCharWidth
@ nCurLine, nCurCol PRINT "DATE2" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 77 * nCharWidth
@ nCurLine, nCurCol PRINT "PAYDESC" FONT cFontName SIZE nFontSize BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
nCurCol2 = nCurCol + 6 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 8 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 19 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 40 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 53 * nCharWidth
nCurCol2 = nCurCol + 12 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 66 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 77 * nCharWidth
nCurCol2 = nCurCol + 20 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

prt_01 := .T.

RETURN 0
*--------------------------------------------------------------
FUNCTION pre_report2 ( _d1, _d2 )

use_report2()
zap

use_cost()

use_payment()

do while .not. eof()

if date1 < _d1 .or. date1 > _d2
   dbskip()
   loop
endif

_date1 = date1
_pay_id = pay_id
_descript = descript
_expense = expense
_payment = payment
_date2 = date2

select cost
seek _pay_id
_paydesc = descript

select report2
dbappend()
replace date1 with _date1
replace pay_id with _pay_id
replace descript with _descript
replace expense with _expense
replace payment with _payment
replace date2 with _date2
replace paydesc with _paydesc

select payment
dbskip()
enddo

dbcloseall()

RETURN

